// 引用  https://web.tianyunperfect.cn/simple/js/util.js
function lt(obj) {
    console.table(JSON.parse(JSON.stringify(obj)));
}

function deepClone(obj) {
    return JSON.parse(JSON.stringify(obj))
}

Date.prototype.format = function (fmt) {
    const o = {
        "M+": this.getMonth() + 1,                 //月份
        "d+": this.getDate(),                    //日
        "h+": this.getHours(),                   //小时
        "m+": this.getMinutes(),                 //分
        "s+": this.getSeconds(),                 //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt)) {
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
    for (const k in o) {
        if (new RegExp("(" + k + ")").test(fmt)) {
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
        }
    }
    return fmt;
};

// 添加响应拦截器
axios.interceptors.response.use(function (response) {
    // 对响应数据做点什么
    return response.data;
}, function (error) {
    // 对响应错误做点什么
    return Promise.reject(error);
});

// 提醒
function my_tip(string) {
    const div = document.createElement("div");
    div.setAttribute("id", "my_alert_danger");
    div.setAttribute("style", "position: fixed; width: 30%; margin-left: 30%; z-index: 2000;");
    div.innerHTML = string;

    document.body.prepend(div);

    setTimeout(() => {
        const element = document.getElementById("my_alert_danger");
        if (element) {
            element.parentNode.removeChild(element);
        }
    }, 2000)
}

// 发送同步请求 let a = sendSyncRequest("https://httpbin.tianyunperfect.cn/ip","GET",1)
function sendSyncRequest(url, method, data) {
    const xhr = new XMLHttpRequest();
    xhr.open(method, url, false);

    if (method.match(/^(POST|PUT)$/i)) {
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.send(JSON.stringify(data));
    } else {
        xhr.send();
    }

    return JSON.parse(xhr.responseText);
}
